indexing
	description:
		"Spezieller Suchalgorithmus, der alle Zeichen hintereinander durchsucht"
class
	BruteForceTextSucher
	-- implementiert Such-Methode

inherit
	TextSucher
		redefine
			Suche
		end
feature
	Suche (Muster: String; Text: Text):Integer is 
			--	Implementation des Suchalgorithmus
		local
			index: Integer;
			found: Boolean
		do
			if Muster.Count=0 then 
				result:= 1
			else
				from
					result:= 0;
					found:= False;
					index:= 1
				until
					found or (index> (Text.getTextString.Count-Muster.Count))
				loop
					if (equal(Muster, Text.getTextString.Substring(index, index+Muster.Count-1))) then
						result:= index
						found:= True
					end;
					index:= index+1
				end	-- form until loop
			end 	--else
		end;
end