indexing
	description:
		"Spezieller Suchalgorithmus, der Vergleich durch Bit-Operationen durchfhrt"

class
	ShiftOrTextSucher
	-- implementiert Such-Methode

inherit
	TextSucher
		redefine
			Suche
		end
feature
	Suche (muster: String; text: Text):Integer is
		--	Implementation des Suchalgorithmus
		local
			b, bits, einsen, nullen: Bit 32;
			i, m, textZeiger: Integer;
			mask: Array [BIT 32];
			found: Boolean
		do
			!! mask.make (1, text.getMAXCHAR);
			einsen:= not (nullen);
			if Muster.Count=0 then
				result:= 1
			else
				result:= 0
				b.put(True, 32);
				--	mask mit einsen belegen
				from
					m:= 1
				until
					m= text.getMAXCHAR
				loop	
					mask.enter (einsen, m);
					m:= m+1
				end
				--	andere Vorbereitung von mask
				from
					m:= 1
				until
					((not b)= einsen) or (m>muster.count)
				loop	
					mask.enter(mask.item(muster.item_code(m)) and (not b), muster.item_code(m))
					b:= b ^ -1
					m:= m+1
				end
				b:= nullen
				b.put(True, 32)
				b:= b ^ -(m-2)	--	eins nach vorn shiften
				-- Eigentliche Suche
				from
					bits:= einsen
					textZeiger:= 1
				until
					(textZeiger= text.getTextString.count+1) or found
				loop
					bits:= (bits ^ -1) or mask.item(text.getTextString.item_code(textZeiger))
					if (bits and b).is_equal(nullen) then
						--	Gefunden !
						found:= True;
						result:= textZeiger-m+2
					end
					textZeiger:= textZeiger+1
				end
			end 	--else
		end;
end

